% !TeX TS-program = lualatex
% !TeX spellcheck = en_US


\documentclass[
ngerman,%globale Übergabe der Hauptsprache
aspectratio=169,%Beamer eigene Option zum Umschalten des Formates
color={accentcolor=2d},
logo=true,%Kein Logo auf Folgeseiten
colorframetitle=true,%Akzentfarbe auch im Frametitle
%	logofile=example-image, %Falls die Logo Dateien nicht vorliegen
]{tudabeamer}
\usepackage[main=english]{babel}

\usepackage{multicol}
\setlength{\columnsep}{1cm}


\usepackage{pgfplots}
\pgfplotsset{compat=1.17}

\usepackage{tikz}
\usetikzlibrary{patterns}


\usepackage{outlines}

%Makros für Formatierungen der Doku
%Im Allgemeinen nicht notwendig!
\let\code\texttt
\newcommand{\ceil}[1]{\lceil {#1} \rceil}

\usepackage{xcolor}
\definecolor{myblue}{HTML}{004E73}


% add some space to itemize lists
\newlength{\wideitemsep}
\setlength{\wideitemsep}{\itemsep}
\addtolength{\wideitemsep}{8pt}
\let\olditem\item
\renewcommand{\item}{\setlength{\itemsep}{\wideitemsep}\olditem}


\title{	Lossless/Lossy Volume Data Compression}
\subtitle{PMPP project - final presentation}
\author[N. Beck \and P. Hollmann]{Niklas Beck \and Paul Hollmann}
\department{Programming Massively Parallel Processors}
\institute{Lossless/Lossy Volume Data Compression}

%Fremdlogo
%Logo Macro mit Sternchen skaliert automatisch, sodass das Logo in die Fußzeile passt
\logo*{\includegraphics{ce_logo_black.pdf}}

% Da das Bild frei wählbar nach Breite und/oder Höhe skaliert werden kann, werden \width/\height entsprechend gesetzt. So kann die Fläche optimal gefüllt werden.
%Sternchenversion skaliert automatisch und beschneidet das Bild, um die Fläche zu füllen.
\titlegraphic{\includegraphics[height=.6\textheight]{stagbeetle.png}\includegraphics[height=.7\textheight]{stagbeetle3.png}}
\date{14th Feb 2022} % ?

\begin{document}
	\maketitle	
	\begin{frame}{Outline}
		\tableofcontents
	\end{frame}
	
	\section{Vector-Quantization}
	\subsection{algorithm and implementation}
	\begin{frame}{parts of the algorithm I}
		\framesubtitle{Vector-Quantization}
		\begin{multicols}{2}
			algorithm split in 4 to 5 parts:
			\begin{itemize}
				\item bricking
				\item initialization part
				\begin{itemize}
					\item using priority-queue or brute-force
				\end{itemize}
				\item relaxation part
				\begin{itemize}
					\item reassign codewords to clustercenters until centers stop moving
				\end{itemize}
				\item psnr-calculation
				\item lookup-table-creation
				\begin{itemize}
					\item actual centerdata put in codewords
				\end{itemize}
			\end{itemize}
			\columnbreak
			
			
			\pause
			
			
			one example : 416x416x247 dataset @ 16 bit
			\usetikzlibrary{patterns}
			\begin{tikzpicture}
				\begin{axis}
					[
					ybar=2pt, % Balkendiagramm = Abstand
					axis x line*=bottom, % Sternchen = no arrow
					axis y line*=left, % Sternchen = no arrow
					ymin=0, % Minimum der y-Achse. Beschriftung über ytick.
					ymax=50,   % Maximum der y-Achse
					enlarge y limits=0.0, % Abstand oben & unten, Prozent
					enlarge x limits=0.25, %  Abstand links & rechts, Prozent
					ylabel={Time in sec},
					legend style={at={(0.75,0.9)},anchor=west,legend columns=1},
					symbolic x coords={bricking,init,relax,{psnr+\\lookup}},
					x tick label style={text width=5cm,align=center},
					xtick={data},
					nodes near coords,
					every node near coord/.append style={
						anchor=south west,
						rotate=45
					},
					width=7cm,
					height=4cm,
					bar width=0.5cm,
					]
					\addplot
					[fill=gray,draw=none] 
					coordinates{
						(bricking,0.765)
						(init,5.354)
						(relax,43.010)
						({psnr+\\lookup},1.478)
					};
				\end{axis}
			\end{tikzpicture}
			using 1 CPU core @ 3.2 GHz {\small \& brute-force init}
		\end{multicols}
	\end{frame}
                 
	\begin{frame}{parts of the algorithm II}
		\framesubtitle{Vector-Quantization}
		\begin{multicols}{2}
			algorithm split in 5 to 6 parts:
			\begin{itemize}
				\item bricking
				\item {\color{myblue} initialization part $\leftarrow$ to GPU}
				\item {\color{myblue} relaxation part $\leftarrow$ to GPU}
				\item psnr-calculation
				\item lookup-table-creation
			\end{itemize}
			\columnbreak
			

			{\color{black!50} one example : 416x416x247 dataset @ 16 bit}
			\usetikzlibrary{patterns}
			\begin{tikzpicture}
				\begin{axis}
					[
					ybar=2pt, % Balkendiagramm = Abstand
					axis x line*=bottom, % Sternchen = no arrow
					axis y line*=left, % Sternchen = no arrow
					ymin=0, % Minimum der y-Achse. Beschriftung über ytick.
					ymax=50,   % Maximum der y-Achse
					enlarge y limits=0.0, % Abstand oben & unten, Prozent
					enlarge x limits=0.25, %  Abstand links & rechts, Prozent
					ylabel={Time in sec},
					legend style={at={(0.75,0.9)},anchor=west,legend columns=1},
					symbolic x coords={bricking,init,relax,{psnr+\\lookup}},
					x tick label style={text width=5cm,align=center},
					%xtick={data},
					x tick style={draw=none},
					xticklabels={none,bricking,init,relax,{psnr+\\lookup}},
					nodes near coords,
					every node near coord/.append style={
						anchor=south west,
						rotate=45
					},
					width=7cm,
					height=4cm,
					bar width=0.5cm,
					]
					
					\addplot
					[fill=gray,draw=none,bar shift=0pt] 
					coordinates{
						(bricking,0.765)
					};
					\addplot
					[fill=myblue,draw=none,bar shift=0pt] 
					coordinates{
						(init,5.354)
					};
					\addplot
					[fill=myblue,draw=none,bar shift=0pt] 
					coordinates{
						(relax,43.010)
					};
					\addplot
					[fill=gray,draw=none,bar shift=0pt] 
					coordinates{
						({psnr+\\lookup},1.478)
					};
				\end{axis}
			\end{tikzpicture}
			{\color{black!50} using 1 CPU core @ 3.2 GHz {\small \& brute-force init}}
		\end{multicols}	\end{frame}

	\begin{frame}{initialization - brute-force algorithm}
		\framesubtitle{Vector-Quantization}
		part on CPU, bigger computations on GPU:
		\begin{itemize}
			\item calculate distances to origin (GPU)
			\item find nearest block to origin (OpenMP Reduction planned) $\rightarrow$ first cluster center 
			\item calculate distances to first cluster center (GPU)
			\item add max distance codeword into array of cluster centers (OpenMP Reduction planned)
			\item repeat to calculate new furthest cluster center $\rightarrow$ add to cluster centers
		\end{itemize}
	\end{frame}
  
	\begin{frame}[allowframebreaks]{relaxation algorithm on GPU}
		\framesubtitle{Vector-Quantization}
		modified simpler algorithm:
		\begin{itemize}                                                        
			\item calculate for each codeword the distances to all cluster centers (85 to 99\% of time)
			\begin{itemize}
				\item 1 codeword - 1 thread
				\item assign codewords to nearest cluster center + flag changed centers
			\end{itemize}
			\item recalculate the position of cluster center with changes in parallel (1 to 15 \% of time)
			\begin{itemize}
				\item 1 cluster center - 32 thread
			\end{itemize}
			\item repeat until no changes in any codeword assignment or cluster center
		\end{itemize}
		\framebreak
		differences to CPU implementation:
		\begin{itemize}                                                        
			\item assignment of codewords with all distance calculations
			\begin{itemize}
				\item time remains almost constant for all iterations
				\item[$\rightarrow$] good if many codewords change (\textasciitilde in first half of iterations)
				\item[$\rightarrow$] CPU version has advantage if few codewords change \& optimizations used
				\begin{itemize}
					\item[idea:] switch to CPU version in that case (for future improvements)
				\end{itemize}
			\end{itemize}
			\item full computation of new position for cluster center
			\begin{itemize}
				\item time after one iteration far less then for codeword assignment
				\item[$\rightarrow$] total time almost negligible 
			\end{itemize}
		\end{itemize}
	\end{frame}

	\begin{frame}{other parts: bricking, psnr-calculation, lookup-table-creation}
		\framesubtitle{Vector-Quantization}
		bricking:
		\begin{itemize}                                                        
			\item is done on CPU and stored via vector-container
			\begin{itemize}                                                        
				\item for other GPU algorithm parts data must be copied to device and back
			\end{itemize}
		\end{itemize}
	
		lookup-table-creation:
		\begin{itemize}                                                        
			\item is also done on CPU 
			\begin{itemize}                                                        
				\item clustered data is written back to original host array for lossless compression
				\begin{itemize}                                                        
					\item[] which will filter it again for duplicates and upload it again to the GPU
				\end{itemize}
			\end{itemize}
		\end{itemize}
		\vspace{0.5cm}
		data management not optimal:
		\begin{itemize}                                                        
			\item many CPU $\leftrightarrows$ GPU memory transfers
			\item some duplicate computations on data
		\end{itemize}
	\end{frame}

	\subsection{performance numbers}
	
	\begin{frame}{initialization performance}
		\framesubtitle{Vector-Quantization}
		\begin{multicols}{2}
			\usetikzlibrary{patterns}
			\begin{tikzpicture}
				\begin{axis}
					[
					ybar=2pt, % Balkendiagramm = Abstand
					axis x line*=bottom, % Sternchen = no arrow
					axis y line*=left, % Sternchen = no arrow
					ymin=0, % Minimum der y-Achse. Beschriftung über ytick.
					ymax=20,   % Maximum der y-Achse
					enlarge y limits=0.0, % Abstand oben & unten, Prozent
					enlarge x limits=0.25, %  Abstand links & rechts, Prozent
					ylabel={Time in sec},
					legend style={at={(0.45,1)},anchor=west,legend columns=1},
					symbolic x coords={ds 1,ds 2,ds 3},
					x tick label style={text width=5cm,align=center},
					xtick={data},
					nodes near coords,
					every node near coord/.append style={
						anchor=south west,
						rotate=65
					},
					width=8cm,
					height=5cm,
					bar width=0.5cm,
					]
					\addplot[fill=black!20,draw=none]
					coordinates{
						(ds 1,14.855)(ds 2,1.339)(ds 3,2.976)
					};
					\addplot
					[fill=black!40,draw=none] 
					coordinates{
						(ds 1,18.278)(ds 2,2.824)(ds 3,5.448)
					};
					\addplot
					[fill=black!60,draw=none] 
					coordinates{
						(ds 1,7.453)(ds 2,0.958)(ds 3,1.686)
					};
					\legend{Priority Queue, Brute Force, Brute Force GPU};
				\end{axis}
			\end{tikzpicture}
			
			\columnbreak
			Testing datasets (ds)
			\begin{itemize}
				\item ds 1: stagbeetle416x416x247 @ 16 bit - lossy 2
				\item ds 2: stagbeetle416x416x247 @ 16 bit - lossy 4
				\item ds 3: christmastree128x124x128 @ \\ 16 bit - lossy 4
				\item bigger datasets are better with the brute force-initialization
				
			\end{itemize}
		\end{multicols}
	\end{frame}
	
	\begin{frame}{overall performance}
		\framesubtitle{Vector-Quantization}
		\begin{multicols}{2}
			\usetikzlibrary{patterns}
			\begin{tikzpicture}
				\begin{axis}
					[
					ybar=2pt, % Balkendiagramm = Abstand
					axis x line*=bottom, % Sternchen = no arrow
					axis y line*=left, % Sternchen = no arrow
					ymin=0, % Minimum der y-Achse. Beschriftung über ytick.
					ymax=50,   % Maximum der y-Achse
					enlarge y limits=0.0, % Abstand oben & unten, Prozent
					enlarge x limits=0.25, %  Abstand links & rechts, Prozent
					ylabel={Time in sec},
					legend style={at={(0.75,0.9)},anchor=west,legend columns=1},
					symbolic x coords={bricking,init,relax,psnr},
					x tick label style={text width=5cm,align=center},
					xtick={data},
					nodes near coords,
					every node near coord/.append style={
						anchor=south west,
						rotate=45
					},
					width=8cm,
					height=5cm,
					bar width=0.5cm,
					]
					%\addplot[fill=gray,draw=none] coordinates{(bricking,5.951)(init,4.264)(relax,692.095)(psnr,15.881)};
					%\addplot[fill=black!20,draw=none] coordinates{(init,2.052)(relax,8.308)};
					\addplot
					[fill=gray,draw=none] 
					coordinates{
						(bricking,0.765)
						(init,5.354)
						(relax,43.010)
						(psnr,1.478)
					}; % TOTAL VQ TIME 50 613ms = 50.613s
					\addplot
					[fill=black!20,draw=none] 
					coordinates{
						(init,1.640) % (bricking,0.790)
						(relax,3.345) % (psnr,1.527)
					};
					\legend{CPU, GPU}; % TOTAL VQ TIME 7307ms = 7.307s
				\end{axis}
			\end{tikzpicture}
			
			\columnbreak
			Testing Environment
			\begin{itemize}
				\item NVIDIA GeForce GTX 1070
				\item Intel Core i7-8700 @ 3.2 GHz {\small only 1 core}
				\item Dataset: stagbeetle416x416x247 {\small @ 16 bit}
				\item lossy = 4: {\small quantized/unique blocks = }$\frac{2105}{33671}$
				\item times include GPU memcopy operations
			\end{itemize}
		\end{multicols}
	\end{frame}

	\section{Evaluation}
	\begin{frame}{Comparison}
		Output:
		\begin{itemize}
			\item depending on chosen vector-quantization parts 
			\begin{itemize}
				\item different assignments and cluster center locations
			\end{itemize}
			\item comparing visually there is almost no visual difference
		\end{itemize}
		Timing:
		\begin{itemize}
			\item relaxation: on same data different number of iterations are needed
			\item depending on dataset times of CPU and GPU can vary a lot
			\begin{itemize}
				\item [idea] {\small choose/switch methods automatically if performance will be better}
			\end{itemize}
		\end{itemize}
	\end{frame}

	\begin{frame}{Evaluation of project}
		\addtolength{\wideitemsep}{-3pt}
		\begin{itemize}
			\item OpenMP for smaller parallelisations not working on our machines
			\begin{itemize}
				\item only one (1) core will be used most of the time
				\item CPU performance maybe 2-4 times better
			\end{itemize}
			\item Vector Quantization: biggest parts are parallelized, lead to significant improvement
			\begin{itemize}
				\item some inefficient memory handling
				\item more optimizations maybe possible 
				\begin{itemize}
					\item reduce memcopy operations, find more points of parallelism, + {\small see previous slides for ideas}
				\end{itemize}
			\end{itemize}
			\item Lossless (RBUC) Compression: more complex
			\begin{itemize}
				\item not adapted into parallel code (task for future), more time gain from vector quantization
				\begin{itemize}
					\item RBUC: 0.367s vs. VQ: 1.58s (GPU) vs. VQ: 9.556s (with ds 3)
					\item RBUC: 7.104s vs. VQ: 18.858s (GPU) vs. VQ: 89.219s (with ds 1)
				\end{itemize}
			\end{itemize}
		\end{itemize}
	\end{frame}

\end{document}
